package org.ucam.srcf.assassins;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.text.ParseException;
import java.util.List;
import java.util.Map;

import org.ucam.srcf.assassins.exceptions.AssassinSQLException;
import org.ucam.srcf.assassins.exceptions.StateBuilderException;
import org.ucam.srcf.assassins.exceptions.XMLParseException;
import org.ucam.srcf.assassins.xml.Config;
import org.ucam.srcf.assassins.xml.Handler;
import org.ucam.srcf.assassins.xml.PageHandler;
import org.ucam.srcf.assassins.xml.WebPageParser;
import org.ucam.srcf.assassins.xml.WebPageParserSAX;

import cx.ath.matthew.cgi.CGI;
import cx.ath.matthew.cgi.CGIInvalidContentFormatException;

public class CGIDynamicPage implements CGICommand {

	public void command(CGI cgi, Map plugins, Map params, long nowtime)
			throws AssassinSQLException, IOException, ParseException,
			StateBuilderException, XMLParseException, CGIInvalidContentFormatException
   {
       cgi.out("<h3></h3>");            
       cgi.flush();
	    StateBuilder sb = new StateBuilder(plugins);
	    Map state = sb.buildStateAtTime(nowtime);
	    Assassin assassin= (Assassin) params.get("assassin");
		if (assassin==null) {
         Player p = (Player) umpirecgi.currentAuth.getPlayerViewer().getEntity();
         List as = p.getAssassins();
         if (as.size() > 0) assassin = (Assassin) as.get(0);
         else assassin = null;
      }
		String pageName = (String) params.get("pageName");
		if (pageName==null) {
			cgi.out("<div class=\"infomessage\">");
			cgi.out("    <p><b>No page specified</b></p>");
			cgi.out("    <p>You may be interested in the following pages:</p>");
			cgi.out("</div>");
			return;
		}
		String path = Config.getConfig("vanilla","path-to-pages")+"/";
		// need to run xsltproc on the page....
	    String xslt_template = Config.getConfig("vanilla","xsl-file");
	    // generate the XML
        try {
           StringWriter sw = new StringWriter();
           PageHandler ph = new PageHandler(sw,pageName,state,plugins,sb.getPages());
           ph.setAssassin(assassin);
           WebPageParser wl = new WebPageParserSAX("xml/"+pageName+",xml",ph);
           wl.generate();
           String xml = sw.toString();
           Process  p = Runtime.getRuntime().exec(new String[] { "/usr/bin/xsltproc", "--novalid", xslt_template, "-"});
           PrintWriter pw = new PrintWriter(new BufferedOutputStream(p.getOutputStream()));
           BufferedReader pr = new BufferedReader(new InputStreamReader(p.getInputStream()));
           pw.write(xml);
           pw.close();
           String html;
           while (null != (html = pr.readLine()))
              cgi.out(html);
           pr.close();
           try { p.waitFor(); } catch (InterruptedException Ie) {}
        } catch (XMLParseException XMLPe) {
           if(Debug.debug) Debug.print(umpirecgi.class, "XML parse error on file "+path+pageName+".xml");
           throw new IOException(XMLPe.getMessage());
        }
	}

	public String getName() {return "Pages";}
	public String getDescription() {return "View Dynamic Pages";}
	public String getSection() {return "Misc";}
	public AuthLevel accessLevel() {return AuthLevel.PUBLIC;}
	public boolean isVisible() {return false;}

}
