/* 
 * CUAG AutoUmpire System
 * 
 * Copyright (C) 2003/2004 Matthew Johnson, Adam Biltcliffe,
 * Michael Cripps, Martin O'Leary, Edward Allcutt and James Osborn
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * To Contact the authors, please email assassins@srcf.ucam.org
 *
 */

package org.ucam.srcf.assassins;

import java.io.IOException;
import java.text.ParseException;
import java.util.Map;

import cx.ath.matthew.cgi.CGI;
import cx.ath.matthew.cgi.CGIHeaderSentException;
import cx.ath.matthew.cgi.CGIInvalidContentFormatException;


import org.ucam.srcf.assassins.exceptions.AssassinSQLException;

public class CGILogout implements CGICommand
{
    private void logout(CGI cgi, Map plugins, Map params) throws CGIInvalidContentFormatException
    {
       try {
          cgi.setcookie("sessionID", "");
       } catch (CGIHeaderSentException CGIHSe) {}
		 String old_user = umpirecgi.currentAuth.invalidateSession();
       cgi.out("<div class=\"infomessage\">");
       cgi.out("  <p><b>Logged Out</b></p>");
	   cgi.out("  <p>Thank you, "+old_user+", you have been logged out.</p>");
       cgi.out("</div>");
       return; 
    }

    public void command(CGI cgi, Map plugins, Map params, long nowtime) 
       throws AssassinSQLException, IOException, ParseException, CGIInvalidContentFormatException { logout(cgi, plugins, params); } 
    public String getName() { return "Logout"; }
    public String getDescription() { return "Logout from the umpire and close your session"; }
    /* At least requireuser to be logged in: */
    public AuthLevel accessLevel () { return AuthLevel.LOGGED_IN; }
    public String getSection() { return null; }
	public boolean isVisible() { return true; }
}

