/* 
 * CUAG AutoUmpire System
 * 
 * Copyright (C) 2003/2004 Matthew Johnson, Adam Biltcliffe,
 * Michael Cripps, Martin O'Leary, Edward Allcutt and James Osborn
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * To Contact the authors, please email assassins@srcf.ucam.org
 *
 */

package org.ucam.srcf.assassins;

import java.io.IOException;
import java.text.ParseException;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Vector;


import cx.ath.matthew.cgi.CGI;
import cx.ath.matthew.cgi.CGIInvalidContentFormatException;
import cx.ath.matthew.cgi.HiddenField;
import cx.ath.matthew.cgi.NewTable;
import cx.ath.matthew.cgi.SubmitButton;
import cx.ath.matthew.cgi.CGIHeaderSentException;
import cx.ath.matthew.cgi.CheckBox;
import cx.ath.matthew.cgi.DisplayField;
import cx.ath.matthew.cgi.TextField;

import org.ucam.srcf.assassins.exceptions.AssassinSQLException;
import org.ucam.srcf.assassins.exceptions.StateBuilderException;
import org.ucam.srcf.assassins.xml.Config;

public class CGIReportDeath implements CGICommand
{
   void reportDeath(CGI cgi, Map plugins, Map params) throws AssassinSQLException, IOException, ParseException , StateBuilderException, CGIInvalidContentFormatException
   { 
      if(Debug.debug)
         Debug.print(CGIReportKill.class, "Pass - "+params.get("pass"));
      // By Mike - fixx0red by matt
      if ("3".equals(params.get("pass"))){ // pass 3
         cgi.out("<h2>Add Your Death At The Hands of Someone Else</h2>");

         /* Set the event properties */
         if (Debug.debug) Debug.print(CGIReportKill.class,  "set event properties");
         Event e = (Event) params.get("event");
         if(null == e) e = new Event();
         EventViewer ev = (EventViewer) e.getViewer();
         setEventProperties(e, params);

         /* build the state */
         if (Debug.debug) Debug.print(CGIReportKill.class,  "build state");
         Map statev = getViewerStateMap(e,cgi);

         /* Deal with the pseudonyms and plugin questions about assassins */
         if (Debug.debug) Debug.print(CGIReportKill.class,  "do pseuds and questions on assassins");
         Iterator i = params.keySet().iterator();
         while (i.hasNext()) {
            String key = (String) i.next();
            if (key.startsWith("assassin")) {
                  if (Debug.debug) Debug.print(CGIReportKill.class,  "3");
               String idx = key.substring(8);
                  if (Debug.debug) Debug.print(CGIReportKill.class,  "4");
               Assassin a = (Assassin) params.get(key);
                  if (Debug.debug) Debug.print(CGIReportKill.class,  "5");
               Pseudonym p = (Pseudonym) params.get("pseudonym"+idx);
               if (Debug.debug) Debug.print(CGIReportKill.class,  "assassin: "+a+" pseud: "+p);
               int id = Integer.parseInt(idx) + 1;
               if ("on".equals(params.get("nopseud"+idx)))
                  e.setParticipant(id, a, null);
               else
                  e.setParticipant(id, a, p);
               AssassinViewer av = (AssassinViewer) a.getViewer();
               Iterator ps = Plugin.getPluginIterator(plugins);
               while (ps.hasNext()) {
                  Plugin pl = (Plugin) ps.next();
                  if (Debug.debug) Debug.print(CGIReportKill.class,  "return questions for "+pl);
                  Vector qs = CGITools.parseQuestions(pl, params, (id-1)*100);
                  if (Debug.debug) Debug.print(CGIReportKill.class,  "1");
                  pl.participantAdded(ev, av, statev, qs);
                  if (Debug.debug) Debug.print(CGIReportKill.class,  "2");
               }
            }
         }
         Event.commitAll();
         StateChange.commitAll();

         if (Debug.debug) Debug.print(CGIReportKill.class,  "event questions form");
         HTMLForm form = new HTMLForm("umpire.cgi?report-death", "Add");
         form.addField(new HiddenField("pass", "4"));
         form.addField(new HiddenField("event", ""+e));
         /* ??? WTF is it doing here ??? */
         /* Just add it on to the above form for now */
         Iterator plgs = Plugin.getPluginIterator(plugins);
         umpirecgi.currentAuth.clearSessionQuestions();
         while (plgs.hasNext()) {
            Plugin pl = (Plugin) plgs.next();
            if (Debug.debug) Debug.print(CGIReportKill.class,  "get questions from "+pl);
            Vector qs = pl.eventAdded(ev, statev, null);
            Iterator qi = qs.iterator();
            for (int j=0; qi.hasNext(); j++) {
               Question q = (Question) qi.next();
               form.addField(CGITools.getPluginField(pl, q, j));
               umpirecgi.currentAuth.addSessionQuestion(pl, q);
            }
         }
         Event.commitAll();
         StateChange.commitAll();

         form.display(cgi); 
      } else if ("4".equals(params.get("pass")))  { // pass 4
         // Done adding deaths, let's ask plugins
         cgi.out("<h2>Add Your Death At The Hands of Someone Else</h2>");
         cgi.out("<div class=\"infomessage\">");
         cgi.out("   <p><b>Event Added</b></p>");
         cgi.out("   <p>Additional questions:</p>");
         cgi.out("</div>");
         additionalQuestionsForm(cgi, params, plugins, 
               (Event) params.get("event")).display(cgi);
      } else if ("5".equals(params.get("pass"))) {// pass 5
         Event e = answerPlugins((Event) params.get("event"), plugins, params, cgi);
         cgi.out("<h2>Add Your Death At The Hands of Someone Else</h2>");
         cgi.out("<div class=\"donemessage\">");
         cgi.out("  <p><b>New Event Added Successfully</b></p>");
         cgi.out("  <p>All statechange events added. All questions asked.</p>");
         cgi.out("</div>");
         try { cgi.header("Refresh", "2; URL=umpire.cgi?edit-event,"+e.getEid()); } catch (CGIHeaderSentException CGIHSe) {} 
         CGIGeneratePages.generatePages(cgi, plugins, params, false);
      } else if ("2".equals(params.get("pass"))) {// pass 2
         cgi.out("<h2>Add Your Death At The Hands of Someone Else</h2>");
         cgi.out("<p>");
         cgi.out("Select Pseudonyms to use");
         cgi.out("</p>");
         parseInvolvedGetDetailsForm(params,plugins, cgi).display(cgi);
      } else { // pass 1
         cgi.out("<h2>Add Your Death At The Hands of Someone Else</h2>");
         cgi.out("<p>");
         cgi.out("Select the assassin who killed you: ");
         cgi.out("</p>");
         selectInvolvedAssassinsForm().display(cgi);
      }
   }


   private static void setEventProperties(Event e, Map params) throws AssassinSQLException, IOException, ParseException , StateBuilderException {
      e.setEventTime(Tools.unFormatTime((String)params.get("event-time")));
      e.setHeadline((String) params.get("headline"));
      e.setActive("on".equals(params.get("active")) ? true : false);
      e.setVisible("on".equals(params.get("visible")) ? true : false);
   }

   private static Map getViewerStateMap(Event e, CGI cgi) throws AssassinSQLException, IOException, ParseException , StateBuilderException, CGIInvalidContentFormatException {
      LightweightStateBuilder lsb = new LightweightStateBuilder(Tools.getNowTime());
      for (Iterator i = e.getParticipants().values().iterator(); i.hasNext();) {
         lsb.registerInterest((Assassin)i.next());
      }

      Map statev = null;
      try {
         statev = Tools.viewerifyStateMap(lsb.generateState());
      } catch (StateBuilderException sbe) {
         printStateBuildError(cgi);
         throw new RuntimeException();
      }

      return statev;
   }

   private static HTMLForm additionalQuestionsForm(CGI cgi, Map params, Map plugins, Event e) throws AssassinSQLException, IOException, ParseException , StateBuilderException, CGIInvalidContentFormatException {
      HTMLForm form;
      form = new HTMLForm("umpire.cgi?report-death", "Answer");
      form.addField(new HiddenField("pass", "5"));

      Map statev = getViewerStateMap(e,cgi);
      EventViewer ev = (EventViewer) e.getViewer();
      Iterator ps = Plugin.getPluginIterator(plugins);
      while (ps.hasNext()) {
         Plugin p = (Plugin) ps.next();
         Vector qs = CGITools.parseQuestions(p, params);
         p.eventAdded(ev, statev, qs);
      }
      Event.commitAll();
      StateChange.commitAll();
      umpirecgi.currentAuth.clearSessionQuestions();

      Iterator scs = e.getStateChanges().iterator();
      for (int idx = 0; scs.hasNext(); idx++) {
         StateChange sc = (StateChange) scs.next();
         ps = Plugin.getPluginIterator(plugins);
         while (ps.hasNext()) {
            Plugin p = (Plugin) ps.next();
            Vector qs = p.stateChangeAdded(sc, statev, null);
            Iterator qi = qs.iterator();
            for (int i=idx*100; qi.hasNext(); i++) {
               Question q = (Question) qi.next();
               form.addField(CGITools.getPluginField(p, q, i));
               umpirecgi.currentAuth.addSessionQuestion(p, q);
            }
         }
      }
      form.addField(new HiddenField("event", ""+e));
      return form;
   }

   private static Event answerPlugins(Event e, Map plugins, Map params, CGI cgi) throws AssassinSQLException, IOException, ParseException , StateBuilderException, CGIInvalidContentFormatException {
      /* Build state for participants */
      Map statev = getViewerStateMap(e,cgi);

      /* Tell plugins about statechanges and answer their questions */
      Iterator scs = e.getStateChanges().iterator();
      for (int idx = 0; scs.hasNext(); idx++) {
         StateChange sc = (StateChange) scs.next();
         Iterator ps = Plugin.getPluginIterator(plugins);
         while (ps.hasNext()) {
            Plugin p = (Plugin) ps.next();
            Vector qs = CGITools.parseQuestions(p, params, idx*100);
            p.stateChangeAdded(sc, statev, qs);
         }
      }
      Event.commitAll();
      StateChange.commitAll();
      umpirecgi.currentAuth.clearSessionQuestions();
      return e;
   }

   private static HTMLForm parseInvolvedGetDetailsForm(Map params, Map plugins, CGI cgi) throws AssassinSQLException, IOException, ParseException , StateBuilderException, CGIInvalidContentFormatException {
      /* Get the list of assassins involved in this event */
      Object o = params.get("assassins");
      List as = new LinkedList();
      if (o instanceof List) 
         as = (List) o;
      else if (o instanceof Assassin)
         as.add(o);

      /* add in the current assassin */
      PlayerViewer pv = umpirecgi.currentAuth.getPlayerViewer();
      Death d = null;
      List l = pv.getAssassins();
      if (l.size() > 0) {
         d = new Death((Assassin) as.get(0), (AssassinViewer) l.get(0));
         as.add(((AssassinViewer)l.get(0)).getEntity());
      }
      
      /* Build state for said assassins */
      LightweightStateBuilder lsb = new LightweightStateBuilder(Tools.getNowTime());
      for (Iterator i=as.iterator(); i.hasNext();) {
         lsb.registerInterest((Assassin)i.next());
      }
      Map myState = null;
      try {
         myState=lsb.generateState();
      } catch (StateBuilderException sbe) {
         printStateBuildError(cgi); 
         throw new RuntimeException();
      }
      Map statev = Tools.viewerifyStateMap(myState);

      /* Create the Event to add stuff to */
      Event e = new Event();
      if (null != d) e.addStateChange(d);
      e.writeDetails();
      EventViewer ev = (EventViewer) e.getViewer();

      /* For each assassin ask pseudonym to use and get plugin questions */
      Iterator i = as.iterator();
      int idx=0;
      HTMLForm form;
      form = new HTMLForm("umpire.cgi?report-death", "Add");
      form.addField(new HiddenField("pass","3"));
	   form.addField(new NewTable("new player "+idx,"PlayerDetails"));
      Vector qs;
      while (i.hasNext()) {
         Assassin a;
         a = (Assassin) i.next();
         AssassinViewer av = (AssassinViewer) a.getViewer();
         form.addField(new HiddenField("assassin"+idx,""+a));
         form.addField(new CanonicalEntityField("pseudonym"+idx,(idx+1)+"."+a.getPlayer().getName(),((AssassinState) myState.get(a)).getPseudonyms(),(CanonicalEntity) null));
         form.addField(new CheckBox("nopseud"+idx, "Use Real Name", false));
         Iterator j = Plugin.getPluginIterator(plugins);
         while (j.hasNext()) {
            Plugin p = (Plugin) j.next();
            qs = p.participantAdded(ev, av, statev, null);
            Iterator qi = qs.iterator();
            for (int k=idx*100; qi.hasNext(); k++) {
               Question q = (Question) qi.next();
               form.addField(CGITools.getPluginField(p, q, k));
               umpirecgi.currentAuth.addSessionQuestion(p, q);
            }
         }
         ++idx;
         if (i.hasNext()) {
            form.addField(new NewTable("new player "+idx,"PlayerDetails"));
         } else {
            form.addField(new NewTable("event details", "EventDetails"));
         }
      }
      Event.commitAll();
      StateChange.commitAll();

      /* Get details about the event */
      form.addField(new TextField("event-time","Event Time:", Tools.formatTime(Tools.getNowTime())));
      String defheadline = Config.getConfig("vanilla", "default-headline");
      form.addField(new TextField("headline","Headline:", null==defheadline?"":defheadline, 40));
      form.addField(new DisplayField("",
               "Headlines may contain the special sequences "+
               "[Pn], [Nn] and [Ln], "+
               "where n is the participant number.<br/> "+
               "[Pn] will be replaced by their pseudonym, "+
               "[Nn] by their name "+
               "and [Ln] by the list of all their pseudonyms."));
      if (umpirecgi.currentAuth.isAtLeast(AuthLevel.UMPIRE)) {
         form.addField(new CheckBox("active","Make Active?", true));
         form.addField(new CheckBox("visible","Make Visible?", true));
      } else {
         form.addField(new HiddenField("active","on"));
         form.addField(new HiddenField("visible","on"));
      }
      form.addField(new HiddenField("event",""+e));
      Event.commitAll();

      return form;
   }
   
   private static void printStateBuildError(CGI cgi) throws IOException, CGIInvalidContentFormatException {
      cgi.out("<div class=\"errormessage\">");
      cgi.out("  <p><b>Internal Error</b></p>");
      cgi.out("  <p>State Building failed! Very bad!!</p>");
      cgi.out("</div>");
      cgi.flush();
   }

   private static HTMLForm selectInvolvedAssassinsForm() throws AssassinSQLException, IOException, ParseException , StateBuilderException {
      List as = Assassin.getAllAssassinsOrderByRealName();
      if (Debug.debug) Debug.print(CGIReportKill.class,  "assassins got: "+as+" ("+as.size()+")");
      HTMLForm form;
      form = new HTMLForm("umpire.cgi?report-death", "Add");
      form.addField(new CanonicalEntityField("assassins","",as,(CanonicalEntity) null));
      form.addField(new HiddenField("pass","2"));
      return form;
   }


   public void command(CGI cgi, Map plugins, Map params, long nowtime) 
      throws AssassinSQLException, IOException, ParseException, StateBuilderException, CGIInvalidContentFormatException {  reportDeath(cgi, plugins, params); } 
   public String getName() { return "Report Your Death"; }
   public String getDescription() { return "Reports a an event where the logged in player was killed by someone else"; }
   public AuthLevel accessLevel () { return AuthLevel.PLAYER; }
   public String getSection() { return "Event"; }
   public boolean isVisible() {	return true; }
}

