/* 
 * CUAG AutoUmpire System
 * 
 * Copyright (C) 2003/2004 Matthew Johnson, Adam Biltcliffe,
 * Michael Cripps, Martin O'Leary, Edward Allcutt and James Osborn
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version. 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details. 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * To Contact the authors, please email assassins@srcf.ucam.org
 *
 */

package org.ucam.srcf.assassins;

import java.io.IOException;
import java.text.ParseException;
import java.util.Map;

import cx.ath.matthew.cgi.CGI;
import cx.ath.matthew.cgi.CGIInvalidContentFormatException;
import cx.ath.matthew.cgi.SubmitButton;
import cx.ath.matthew.cgi.TextField;

import org.ucam.srcf.assassins.exceptions.AssassinSQLException;

public class CGISetTime implements CGICommand
{
   private void setTime(CGI cgi, Map plugins, Map params) throws CGIInvalidContentFormatException
   {
      cgi.out("<p>");
      cgi.out("   This function allows you to set the time that the autoumpire");
      cgi.out("   treats as now. This means that you can get the state as if it");
      cgi.out("   were some other time.");
      cgi.out("</p>");
      HTMLForm form = new HTMLForm("umpire.cgi","Set Effective Time");
      form.addField(new TextField("nowtime","Set Effective Time To",
               Tools.formatTime(Tools.getNowTime())));
      form.addField(new SubmitButton("resettime", "Reset Time"));
      form.display(cgi);
   }

   public void command(CGI cgi, Map plugins, Map params, long nowtime) 
      throws AssassinSQLException, IOException, ParseException, CGIInvalidContentFormatException { setTime(cgi, plugins, params); } 
   public String getName() { return "Set Effective Time"; }
   public String getDescription() { return "Run the autoumpire as if it were a different time"; }
   public AuthLevel accessLevel () { return AuthLevel.UMPIRE; }
   public String getSection() { return "Misc"; }
   public boolean isVisible() {	return true; }
}


